
%P1Stage1

clearvars % Clear memory of all variables in previous runs of the program.

% Reading of data Excel file by loading the data to the initial data matrix Datoscero.

file=input('Data file (e.g., data_stage1.xlsx): ','s')

Datoscero = xlsread(file); 

dimensiones = size(Datoscero); % The dimensions of the Datoscero matrix are obtained.
    comunas=dimensiones(1,2)-1; % The number of communes is the number of columns minus 1 (because the first column of data is for time).
   
    for comuna=1:1:comunas % Calculations are made by commune.
    comuna % To display on screen.
    
        % To obtain number of pre-quarantine days. 
        
        ultimamedicion=0;
        delta=1;

        for i=2:1:dimensiones(1,1)
        
            if Datoscero(i,comuna+1)==-1
                delta=0;
            end
            
            ultimamedicion=ultimamedicion + delta;        
        end
       
        
    %_______________________________________   
        
    % The data is then prepared as to be used by the ajustemodelo1() function.
    
     % The Datos matrix is created, which is only for the commune indicated in the cycle. 
     % It lists in the first column the days from day 1 and in the second column it contains the initial confirmed cases.
    
 
 
    clearvars Datos;
    
    Datos = [Datoscero(2:ultimamedicion+1, 1), Datoscero(2:ultimamedicion+1, comuna+1)]; % There is displacement in 1, since Datoscero has the days from the second row, 
                                                                                         % and the confirmed cases from the second column (and according to which commune the column corresponds to).          
% Population of the commune.
      N=Datoscero(1, comuna+1);
   
      
% Initial parameters to later start the algorithm in the  ajustemodelo1() function.
alfa0=0.2967; % for Chine model without quarantine.
beta0=0.385; % 55% symptomatic + 70% sensitivity. Tentative initial value for beta.
gama0=0.3; % Tentative initial value for gama.
Q00=(Datos(2,2)-Datos(1,2))/beta0; % Approximation using the 4th equation of model 2 (Zhao and Chen 2020).

if Q00<0 
    Q00=0;
end

U00=((Datos(3,2)-Datos(2,2))-(Datos(2,2)-Datos(1,2)))/(beta0*gama0)+Q00*beta0/gama0; % Approximation using the 3rd equation of model 2 (Zhao and Chen 2020).
if U00<1 
    U00=1;
end

% Calculation of the correlation index and the four adjustment parameters.
[Ufinalteorico, Qfinalteorico,r, estimates]=ajustemodelo1(Datos, N, alfa0, beta0, gama0, U00, Q00,ultimamedicion,comuna); % You can consult the file of the ajustemodelo1() function. 

%________________________________________
% The results of all the communes are loaded in arrays.
comunavector(comuna)=comuna;
Nvector(comuna)=N;
alfavector(comuna)=alfa0;
betavector(comuna) = estimates(1);
gamavector(comuna) = estimates(2);
U0vector(comuna) = estimates(3);
Q0vector(comuna) = estimates(4);
Re_vector(comuna)=alfavector(comuna)/(gamavector(comuna)+1/14);
R2vector(comuna)=r(1,2)^2; % Determination coefficient for each commune.


Ufinalteoricovector(comuna)=Ufinalteorico;
Qfinalteoricovector(comuna)= Qfinalteorico;
%________________________________________

    end % The end of the calculation cycle for each commune.

R2vector % Display on screen.

% Results matrix for Excel exportation.
Matriz = [comunavector; Nvector; alfavector; U0vector; Q0vector; gamavector; betavector; Re_vector; R2vector]; 

Matriz2 = [comunavector;Ufinalteoricovector; Qfinalteoricovector];

% Building of Excel file with the results matrix.
xlswrite('output_P1Stage1.xlsx',Matriz,'Hoja1','B2')
xlswrite('U0Q0_for_P1Stage2.xlsx',Matriz2,'Hoja1','A1')