function [Ufinalteorico, Qfinalteorico,r, estimates] = ajustemodelo1(Datos, N, alfa0, beta0, gama0, U00, Q00,ultimamedicion, comuna)

% This program calculates the curve fitting and overlays it with the experimental data.

% Configuring the fit using the fmincon() function.
A=[];
b=[];
Aeq=[];
beq=[];

lb=[0,0,0,0]; % Minimum parameter values.
ub=[1,1,N,N]; % Maximum parameter values.

start_point= [beta0, gama0, U00, Q00]; % Initial parameter values to start fitting.

estimates = fmincon(@mifun, start_point, A,b,Aeq,beq,lb,ub);
function sse=mifun(params, file);

% ___________________________________

% Notation for fitting parameters. 
beta = params(1);
gama = params(2);
U0 = params(3);
Q0 = params(4);

alfa=alfa0;

C = Datos(:, 2); % Confirmed case data. 

C0 = C(1);
S0 =N-U0-Q0-C0;

indices=size(Datos);

diastotales=Datos(indices(1,1), 1)-Datos(1, 1)+1;
%__________________________________
% Calculation of the error (sse) obtained by the deviation between the
% theoretical and the experimental values.

% Clearing memory variables.
clear t
clear y
clear Cteorico
clear Tiempo

% Calculations of the theoretical values of C (Theoretical confirmed cases, indicated as Cteorico)
    
   [t,y]= ode45(@campomodelo, [Datos(1, 1) Datos(indices(1,1), 1)], [S0,U0,Q0,C0], [], N, alfa, beta, gama); 

   
    dimensiones = size(y); 
    tiempoenUA=dimensiones(1,1); % Total time, in arbitrary units, of the data record. (It is the total of the calculated values of C)
    
for medicion=1:1:indices(1,1) % indices=size(Datos);
    
    i=0;
    for coordenadadetiempo=1:1:tiempoenUA
            
        if t(coordenadadetiempo)<=Datos(medicion,1)
          
        
            Cteorico(medicion)=y(coordenadadetiempo,4);
        elseif i==0
            Cteorico(medicion)=y(coordenadadetiempo,4);
            i=1+1;
                    
        end
    end
    
    ErrorVector1(medicion) = Cteorico(medicion) - C(medicion);
    Tiempo(medicion)=Datos(medicion,1);
  
end

sse = sum(ErrorVector1.^2); % error (cost function, which must be minimized by adjusting parameters)

end

% This block of final values of the variables can be very useful in the case of using a pandemic end time. 
Sfinalteorico=y(coordenadadetiempo,1);  
Ufinalteorico=y(coordenadadetiempo,2);
Qfinalteorico=y(coordenadadetiempo,3);
Cfinalteorico=y(coordenadadetiempo,4);


NTotalteoricodelfinal = Sfinalteorico + Ufinalteorico + Qfinalteorico + Cfinalteorico; %Control

Error_porcentual_en_N_calculado = 100*(NTotalteoricodelfinal-N)/N   % It is for checking. The variation must be due to the recovered individuals.
%__________________________________

if comuna==30 % Commune 30 will be graphed.
% At this level the parameters have already been estimated by mean of minimizing the error function.
% These parameters are then used in the generation of the graph showing the adjustment.
% The theoretical curve and the empirical data points are plotted.  

plot(Tiempo,C,'ko',t, y(:,4),'--k','MarkerFacecolor','k');

axis([Datos(1, 1),Datos(indices(1,1), 1),0,10000]);
ylabel('Casos confirmados');
xlabel('Das');

end
r= corrcoef(Cteorico,C); % With r(1,2) the Pearson correlation coefficient.

end